#include <mega8.h>
#include <delay.h>

int adc=0;
eeprom int temp=0;
eeprom int flow=0;

// Voltage Reference: Int., cap. on AREF
#define ADC_VREF_TYPE ((1<<REFS1) | (1<<REFS0) | (0<<ADLAR))

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=(1<<ADSC);
// Wait for the AD conversion to complete
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA|=(1<<ADIF);
return ADCW;
}
 //char  Number[12]={0b01110111,0b01100000,0b00111011,0b01101100,0b01011101,0b01011111, 0b01110100,0b01111111,0b01111101,0b00011110,0b00000111 };
void number(int num, int dot)
{    
switch (num) {
        case 0:
              PORTD=0b01110111;
              break;
        case 1:
              PORTD=0b01100000; 
              break;  
        case 2: 
              PORTD=0b00111011;
              break;
        case 3: 
              PORTD=0b01111001;
              break;                
        case 4: 
              PORTD=0b01101100;
              break;     
        case 5: 
              PORTD=0b01011101;
              break; 
        case 6: 
              PORTD=0b01011111;
              break;  
        case 7: 
              PORTD=0b01110100;
              break;       
        case 8: 
              PORTD=0b01111111; 
              break;         
        case 9: 
              PORTD=0b01111101;
              break;  
        case 10:  //F
              PORTD=0b00011110;
              break;
        case 11:   //L
              PORTD=0b00000111;
              break;                    
            }       
     if (dot) {PORTD |= 1 << 7;}
}

char encoder;
//FSM on encoder 
int Encoder_f(void)
{     int inc=0;//increment
encoder=(encoder<< 2)+2*PINB.4+PINB.5;
  switch (encoder&0x0F) {  
             case 7: 
             inc=inc+1;
             break;
             case 14: 
             inc=inc+1;
             break;     
             case 8: 
             inc=inc+1;
             break;
             case 1: 
             inc=inc+1;
             break; 
             case 13: 
             inc=inc-1;
             break;
             case 4: 
             inc=inc-1;
             break;     
             case 2: 
             inc=inc-1;
             break;
             case 11: 
             inc=inc-1;
             break;
             default:
             break;
      }      
      return inc;
}


int fan(int val)
{ int velo;

      switch (val) {
    case 0:
    velo=0;
    break;
    case 1:
    velo=0x0200;
    break;
    case 2:
    velo=0x0240;
    break;
    case 3:
    velo=0x0280;
    break;
    case 4:
    velo=0x02C0;
    break;
    case 5:
    velo=0x0300;
    break;
    case 6:
    velo=0x0340;
    break;
    case 7:
    velo=0x0380;
    break;
    case 8:
    velo=0x03C0;
    break; 
    case 9:
    velo=0x03FF;
    break;
    };


 return  velo;
}

// show_num() -- display 3 digit number
void show_num(int inum,int idel)
{
//inum -- number to show on 3 digit indicator
//idel -- delay between digits switching for dynamic indication
number(inum%10,0); //ones
PORTB.0=1; PORTB.7=0;  PORTB.6=0;
delay_ms(idel);
number((inum%100-inum%10)/10,0);  //tens
PORTB.0=0; PORTB.7=1;  PORTB.6=0;
delay_ms(idel);
number((inum%1000-inum%100)/100,0); //hundrets
PORTB.0=0; PORTB.7=0;  PORTB.6=1;
delay_ms(idel); 
}

// show_sym() -- display 3 digit number in format d1 d2 d3 
void show_sym(int d1,int d2, int d3, int idel)
{
//idel -- delay between digits switching for dynamic indication
number(d3,0); //ones
PORTB.0=1; PORTB.7=0;  PORTB.6=0;
delay_ms(idel);
number(d2,0);  //tens
PORTB.0=0; PORTB.7=1;  PORTB.6=0;
delay_ms(idel);
number(d1,0); //hundrets
PORTB.0=0; PORTB.7=0;  PORTB.6=1;
delay_ms(idel); 
}
//Button (encoder) polling on timer interrupt 
  int dirL=0; 
  int dirR=0;
  int Enc_val=0; 
  int push=0;  
  interrupt [TIM0_OVF] void timer0_ovf_isr(void)
    {
     int inc=Encoder_f();   
     if (inc>0)     {dirR++;}  
     if (inc<0)     {dirL++;} 
     if (dirR==4) {Enc_val+=1; dirR=0; dirL=0;}   //one click of encoder is increase in 4
     if (dirL==4) {Enc_val-=1; dirR=0; dirL=0;} 

     //check encoder button  
     if(PINB.3==0) {delay_ms(200); push+=1; if (push==3) {push=0;}}  //Source of problems??? 200ms
     //Heater part 
     if(PINC.5==1)  {
        if (adc<temp) {PORTC.0=1;}
        else          {PORTC.0=0;}  
        }   
     else {        
     
         show_sym(0,10,10,1);     //Show "OFF" 
         PORTB.1=0; //Relay off  
         PORTC.0=0; //Optocoupler off   
         //check if flow!=0. Here a priory flow!=0
         //Safety check on heater temperature
         if (adc<60){ OCR1B=0;}  //wait while heater will be cold 
         }
     }



int adc_val;
void main(void)
{       if (temp>999){temp=999;}      
        if (temp<0)  {temp=0;}
        if (flow>9)  {flow=9;}
        if (flow<0)  {flow=0;}  
      
PORTB=0x00;
DDRB=0xC7;

PORTC=0x00;
DDRC=0x01;

PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125 kHz
TCCR0=(0<<CS02) | (1<<CS01) | (0<<CS00);
TCNT0=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);

// ADC initialization
// ADC Clock frequency: 7,813 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x87;

TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<WGM11) | (1<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00; 


  // Global enable interrupts
#asm("sei")

while (1)
   {   
   adc_val= read_adc(4);//CALIBRATION!!!
   adc=0.8*adc+0.2*adc_val;   //Kalman filter 
    //Regime
   if(PINC.5==0)      // read switch (gerkon)  -- Off regime
      {  
         push=0;//After recover go to first item of menu
      }  
      else
      {   
      PORTB.1=1; //Relay on  
      //Menu
      switch (push) {
        case 0:  //show temperature
            show_num(adc, 1);
            break;  
        case 1:  //set temperature  
            show_num(temp, 1);
            temp+=Enc_val;
            if (temp>999) {temp=999;}
            if (temp<0) {temp=0;}
            Enc_val=0;
            break; 
        case 2: //set flow
            show_sym(10,11,flow, 1);
            flow+=Enc_val;
            if (flow>9) {flow=9;}
            if (flow<0) {flow=0;}
            Enc_val=0;
            break;
        }; //end switch 
      OCR1B=fan(flow);//Transistor -- fan       
      }  //end if
         
   }  //end while 
      
}        // end main
